/*
 *	hsdma.c - DMA
 *
 *	* Wed Jan 16 21:25:00 JST 2002 Naoyuki Sawa
 *	- 1st release.
 */
#include <piece.h>
#include <s1c33cpu.h>
#include "c33208.h"

#define plc_IO ((volatile struct c_IOtag*)0x40000)	/* c33208.hp */
char vbuff[DISP_X * DISP_Y];			/* zVRAM */
#define MSG_SIZE 16
char msg[MSG_SIZE] = "ɂ́I";		/* \郁bZ[W */
char msg_new[MSG_SIZE] = "悤Ȃ`";	/* ]郁bZ[W */

/****************************************************************************
 *	pceAppInit
 ****************************************************************************/

void
pceAppInit()
{
	/* ʏ̏B */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceAppSetProcPeriod(100);
	pceLCDDispStart();

DISABLE;
	/* DMA Ch.3mɒ~܂B
	 * A쒆ƁARg[񂪐ݒł܂B
	 */
	HS3_DISABLE;

	/* DMA Ch.3̃gKvƂāA\tgEFAgKI܂B
	 * ŁAHS3_K54F(R)IAbK5_CFK5_CFK54=1ƂĂ΁A
	 *   X^[g{^DMAgKɂȂ邩Ǝv̂łA
	 *   ۂɎĂ݂ƁA蓮Ȃ肵܂B(ȂƂ̕ł)
	 *   PɃ\tgEFA̐ݒ肾ł́AK5x|[gDMAREQɐ؂ւȂ̂ł傤B
	 */
	bHSDMA_HTGR2_HSD3S = HS3_SOFT;

	/* AhX[h(fA)A]TCYݒ肵܂B */
	pHS3_CNT = (1 << 31) | MSG_SIZE;

	/* ]P(oCg)A]AhX()A]AhXݒ肵܂B
	 * c33208.hł́Ã[h̃rbg31DINTEN`Ă܂A
	 *   S1C33209ł́ÃrbgreservedłB
	 *   DMÅ荞݃Cl[urbǵAł͂ȂA
	 *   荞݃Rg[WX^̗̈(0x40271)ɂ܂B
	 *   CeWFgDMǍ`ƊԈ̂ł͂ȂƎv܂B
	 *   Ƃ肠AgȂΖ肠܂B
	 */
	pHS3_SADR = (3 << 28) | (int)msg_new;

	/* ][h(A)A]AhX()A]AhXݒ肵܂B */
	pHS3_DADR = (1 << 30) | (3 << 28) | (int)msg;

	/* AɃgKĂƁAHS3_ENABLE r[ɓ]JnĂ܂̂ŁA
	 * mɃgKtONAĂ܂B
	 */
	pHS3_TF = 1;

	/* DMA Ch.3Lɂ܂B
	 * gK܂ŁA҂ԂƂȂĂ܂B
	 */
	HS3_ENABLE;
ENABLE;
}

/****************************************************************************
 *	pceAppExit
 ****************************************************************************/

void
pceAppExit()
{
	/* mɁADMA Ch.3~܂B */
DISABLE;
	HS3_DISABLE;
ENABLE;
}

/****************************************************************************
 *	pceAppProc
 ****************************************************************************/

void
pceAppProc(int count)
{
	/* 50Ă΂ꂽAI܂B */
	if(count == 50) {
		pceAppReqExit(0);
		return;
	}

	/* 25Ă΂ꂽAVbZ[W]܂B */
	if(count == 25) {
DISABLE;
		/* bHSDMA_HSOFTTGR_HST3 = 1 ƂƁAӖȃ[h/ft@C/CgɂȂ܂B
		 *   1񂾃rbgɂ݈̂Ӗ郌WX^(荞݃NAł)ɂ́A
		 *   rbgtB[hg킸Aڃrbgp^[w肵SƎv܂B
		 */
		pHSDMA_HSOFTTGR = 1 << 3;
ENABLE;
	}

	/* bZ[W\܂B */
	memset(vbuff, 0, sizeof vbuff);
	pceFontSetPos(40, 40);
	pceFontPrintf(msg);
	pceLCDTrans();
}
